routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\RepairOrderController;
use App\Http\Controllers\TestController;
use App\Http\Controllers\PdfController;
use Illuminate\Http\Request;
use App\Models\RepairOrder;
use App\Models\Parameter;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

// test
Route::get('/test', [TestController::class, 'index'])->name('test');

Route::redirect('/', '/login');

Route::get('/login', [LoginController::class, 'showLoginPage'])->middleware('admin.user.auth')->name('login.page');

Route::post('/login', [LoginController::class, 'login'])->name('login');

Route::get('/logout', [LoginController::class, 'logout'])->name('logout');

Route::redirect('/dashboard', '/repair_order');

// Route::get('/dashboard', function () {

//     return view('pages.dashboard');

// })->middleware('admin.user.auth')->name('dashboard');

// 任務
// Route::resource('task', TaskController::class)->middleware('admin.user.auth');

// 維修工單
Route::resource('repair_order', RepairOrderController::class)->middleware('admin.user.auth');

// 匯出

Route::post('/export/repair_order', [RepairOrderController::class, 'export'])->name('export.repair_order');

Route::get('/export_pre/repair_order', [RepairOrderController::class, 'exportPreview']);

// pdf

Route::get('/download-pdf/test', [TestController::class, 'domwloadPdf']);

Route::get('/download-pdf/{name}/{sn}', [PdfController::class, 'downloadPdf'])->name('download-pdf');

Route::get('/preview-pdf/{name}/{sn}', [PdfController::class, 'previewPdf'])->name('preview-pdf');

app/Models/RepairOrder.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Builder;

class RepairOrder extends Model
{
    use HasFactory;
    use SoftDeletes;

    // protected $primaryKey = 'sn'; // 已在 Model 設定

    // protected $fillable = [
    //     'no',
    //     'name',
    //     'mobile',
    //     'phone',
    //     'company_name',
    //     'tax_id_number',
    //     'tax_id_number',
    //     'order_day',
    //     'modify_day'
    // ];
    protected $guarded = [];
    protected static $applyAccessors = false;

    public $check_names = ['0' => '否', '1' => '是', '2' => '無法檢測'];


    public static function getFieldNames()
    {
        return [
            'no' => '維修單號',
            'name' => '姓名',
            'mobile' => '手機號碼',
            'phone' => '市話',
            'company_name' => '公司名稱',
            'tax_id_number' => '統編',
            'engineer' => '收單工程師',
            'device_type' => '設備類型',
            'device_brand' => '廠牌',
            'device_model' => '型號',
            'device_serial_number' => '序號',
            'device_cpu' => 'CPU',
            'device_ram' => 'RAM',
            'device_hdd' => 'HDD',
            'device_ssd' => 'SSD',
            'device_power' => 'POWER',
            'device_accessories' => '配件',
            'device_pwd_lock' => '密碼鎖',
            'device_pattern_lock' => '圖形鎖',
            'appearance_desc' => '外觀描述',
            'error_desc' => '故障描述',
            'repair_report' => '處理報告',
            'before_check_btn' => '維修前按鈕',
            'after_check_btn' => '維修後按鈕',
            'before_check_monitor' => '維修前網路',
            'after_check_monitor' => '維修後螢幕',
            'before_check_internet' => '維修前網路',
            'after_check_internet' => '維修後網路',
            'before_check_call' => '維修前通話',
            'after_check_call' => '維修後通話',
            'before_check_camera' => '維修前鏡頭',
            'after_check_camera' => '維修後鏡頭',
            'before_check_bottom' => '維修前尾插',
            'after_check_bottom' => '維修後尾插',
            'before_check_speaker' => '維修前喇叭',
            'after_check_speaker' => '維修後喇叭',
            'data_delete_check' => '可刪除資料',
            'payment_pre_tax_price' => '未稅總價',
            'payment_tax_price' => '稅金',
            'payment_total_price' => '合計總價',
            'payment_downpayment' => '已付訂金',
            'payment_finalpayment' => '應收尾款',
            'payment_testing_charges' => '檢測費用',
            'notify_method' => '通知方式',
            'notify_date' => '通知日期',
            'pickup_date' => '取件日期',
            'sales' => '收款業務',
            'order_day' => '收件日期'
        ];
    }

    public static function getExportFields()
    {
        return [
            'no',
            'name',
            'mobile',
            'phone',
            'company_name',
            'tax_id_number',
            'engineer',
            'device_type',
            'device_brand',
            'device_model',
            'device_serial_number',
            'device_cpu',
            'device_ram',
            'device_hdd',
            'device_ssd',
            'device_power',
            'device_accessories',
            'device_pwd_lock',
            'device_pattern_lock',
            'appearance_desc',
            'error_desc',
            'repair_report',
            'before_check_btn',
            'after_check_btn',
            'before_check_monitor',
            'after_check_monitor',
            'before_check_internet',
            'after_check_internet',
            'before_check_call',
            'after_check_call',
            'before_check_camera',
            'after_check_camera',
            'before_check_bottom',
            'after_check_bottom',
            'before_check_speaker',
            'after_check_speaker',
            'data_delete_check',
            'payment_pre_tax_price',
            'payment_tax_price',
            'payment_total_price',
            'payment_downpayment',
            'payment_finalpayment',
            'payment_testing_charges',
            'notify_method',
            'notify_date',
            'pickup_date',
            'sales',
            'order_day'
        ];
    }

    protected function replaceCheckValue($value)
    {
        return $this->check_names[$value];
    }

    public function __get($key)
    {
        // 如果访问器未启用，直接返回原始属性值
        if (!static::$applyAccessors) {
            return parent::__get($key);
        }

        // 检查是否有需要替换逻辑的字段
        $fields_to_replace = [
            'before_check_btn',
            'after_check_btn',
            'before_check_monitor',
            'after_check_monitor',
            'before_check_internet',
            'after_check_internet',
            'before_check_call',
            'after_check_call',
            'before_check_camera',
            'after_check_camera',
            'before_check_bottom',
            'after_check_bottom',
            'before_check_speaker',
            'after_check_speaker',
            'data_delete_check'
        ];

        if (in_array($key, $fields_to_replace)) {
            return $this->replaceCheckValue(parent::__get($key));
        }

        return parent::__get($key);
    }

    // 方法来禁用访问器
    public static function enableAccessors()
    {
        static::$applyAccessors = true;
    }

    // 局部作用域来启用访问器
    public function scopeWithAccessors(Builder $query)
    {
        static::enableAccessors();
        return $query;
    }

}

app/Http/Controllers/RepairOrderController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RepairOrder;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use App\Models\Parameter;
use App\Exports\RepairOrderExport;
use Maatwebsite\Excel\Facades\Excel;

class RepairOrderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        // DB::enableQueryLog();

        // 创建查询构建器
        $repair_orders_query = RepairOrder::query();

        // 定义查询条件
        $conditions = [
            'mobile' => $request->mobile,
            'name' => $request->name,
            // 可以继续添加其他查询条件
        ];

        // 根据条件动态添加查询
        foreach ($conditions as $field => $value) {
            $repair_orders_query->when($value, function ($query, $value) use ($field) {
                return $query->where($field, $value);
            });
        }

        // 添加排序
        $repair_orders_query->orderByDesc('sn');

        // 执行查询并进行分页
        $repair_orders = $repair_orders_query->paginate(10);

        // 返回视图并传递分页结果
        return response(view('pages.repair_order.index', compact('repair_orders')));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $param = $this->getParameter(['device_type', 'device_brand', 'device_model', 'device_accessory']);

        return response(view('pages.repair_order.create', compact('param')));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $repair_order_no = $this->generateOrderNo();

        $request_data = $request->only(Schema::getColumnListing((new RepairOrder)->getTable()));

        if (empty($request_data['data_delete_check']))
            $request_data['data_delete_check'] = '0';

        if (!empty($request_data['device_accessories']))
            $request_data['device_accessories'] = implode(',', $request_data['device_accessories']);

        $request_data['no'] = $repair_order_no;
        $request_data['order_day'] = thisDay();
        $request_data['modify_day'] = thisDay();

        RepairOrder::create($request_data);

        if ($request->device_type) {

            $this->checkParameter('device_type', $request->device_type);
        }

        if ($request->device_brand) {

            $this->checkParameter('device_brand', $request->device_brand);
        }

        if ($request->device_model) {

            $this->checkParameter('device_model', $request->device_model);
        }

        if ($request->device_accessories) {

            foreach ($request->device_accessories as $device_accessory) {

                $this->checkParameter('device_accessory', $device_accessory);
            }
        }

        return redirect()->route('repair_order.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $sn
     * @return \Illuminate\Http\Response
     */
    public function show($sn)
    {
        // Log::info('Showing the user profile for user: ', ['sn' => $sn]);

        // Log::info('User failed to login.', ['sn' => $sn]);

        $repair_order = RepairOrder::where('sn', $sn)->first();

        return response(view('pages.repair_order.show', compact('repair_order')));

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $sn
     * @return \Illuminate\Http\Response
     */
    public function edit($sn)
    {
        // DB::enableQueryLog();

        $repair_order = RepairOrder::where('sn', $sn)->first();

        $repair_order->device_accessories = explode(',', $repair_order->device_accessories);

        // $queries = DB::getQueryLog();

        // dd($queries);

        $param = $this->getParameter(['device_type', 'device_brand', 'device_model', 'device_accessory']);

        if ($repair_order) {

            return response(view('pages.repair_order.edit', compact('repair_order', 'param')));

        } else {

            return response(view('pages.repair_order.edit', compact('repair_order', 'param')));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $sn
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $sn)
    {
        // dd($request->all());
        $request_data = $request->only(Schema::getColumnListing((new RepairOrder)->getTable()));

        if (empty($request_data['data_delete_check']))
            $request_data['data_delete_check'] = '0';

        if (!empty($request_data['device_accessories']))
            $request_data['device_accessories'] = implode(',', $request_data['device_accessories']);

        $request_data['modify_day'] = thisDay();

        RepairOrder::findOrFail($sn)->update($request_data);

        if ($request->device_type) {

            $this->checkParameter('device_type', $request->device_type);
        }

        if ($request->device_brand) {

            $this->checkParameter('device_brand', $request->device_brand);
        }

        if ($request->device_model) {

            $this->checkParameter('device_model', $request->device_model);
        }

        if ($request->device_accessories) {

            foreach ($request->device_accessories as $device_accessory) {

                $this->checkParameter('device_accessory', $device_accessory);
            }
        }

        return redirect()->route('repair_order.edit', $sn);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $sn
     * @return \Illuminate\Http\Response
     */
    public function destroy($sn)
    {
        RepairOrder::findOrFail($sn)->delete();

        return redirect()->route('repair_order.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param array $category
     * @return array
     */
    public function getParameter($categories)
    {
        $param = [];

        $parameters = Parameter::whereIn('category', $categories)->get();

        foreach ($parameters as $parameter) {

            $param[$parameter->category][] = $parameter->value;
        }

        return $param;
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param string $category
     * @param string $value
     * @return void
     */
    public function checkParameter($category, $value)
    {

        Parameter::firstOrCreate(['category' => $category, 'value' => $value]);
    }

    public function export(Request $request)
    {
        $file_name = 'export_repair_order_' . date('YmdHis') . '.xls';

        return Excel::download(new RepairOrderExport($request), $file_name);
    }

    public function exportPreview(Request $request)
    {
        // $repair_orders = RepairOrder::all();
        $repair_orders = RepairOrder::withAccessors()->get(); // withAccessors 啟動字段替換

        $fields = array_intersect(Schema::getColumnListing((new RepairOrder)->getTable()), RepairOrder::getExportFields());

        $field_names = RepairOrder::getFieldNames();

        return view('excels.repair_order', compact('repair_orders', 'fields', 'field_names'));
    }

    public function generateOrderNo()
    {
        $latest_order = RepairOrder::orderByDesc('sn')->first();

        if (substr($latest_order->no, 0, 3) == 'LIY') {

        } else {
            $repair_order_no = 'LIY020918';
        }

        return $repair_order_no;
    }
}

resources/views/pages/repair_order/index.blade.php
@extends('layouts.admin')

@section('title', '維修單')

@section('content')

    <div class="admin-navbar shadow-lg p-3 mb-5 bg-body rounded">
        <div class="d-flex position-relative">
            <ul class="d-flex">
                <li class="nav-item">
                    <a href="{{ route('repair_order.create') }}"><button type="button" class="btn btn-outline-primary">新增</button></a>
                </li>
                <li class="nav-item">
                    <button type="button" class="btn btn-outline-primary" onclick="showExportOption()">匯出</button>
                </li>
            </ul>
            <div class="position-absolute end-0">
                <form class="d-flex" action="{{ route('repair_order.index') }}" method="GET">
                    @csrf
                    <input type="search" class="form-control me-2" placeholder="手機查詢..." aria-label="Search" name="mobile" value="{{ isset($_GET['mobile']) ? $_GET['mobile'] : '' }}">
                    <button class="btn btn-outline-primary" type="submit">Search</button>
                </form>
            </div>
            <div id="swal-export-options" class="d-none">
                <form action="{{ route('export.repair_order') }}" method="POST">
                    @csrf
                    <div class="export-option-block w-100 text-start">
                        <div class="row mb-4 w-100 mx-auto g-0 justify-content-between">
                            <div class="col-5">
                                <label for="form_export_start_date" class="form-label">開始日期</label>
                                <input type="date" class="form-control" id="form_export_start_date" name="export_start_date">
                            </div>
                            <div class="col-5">
                                <label for="form_export_end_date" class="form-label">結束日期</label>
                                <input type="date" class="form-control" id="form_export_end_date" name="export_end_date">
                            </div>
                        </div>
                        <div class="row w-100 text-end g-0">
                            <div class="col">
                                <button type="submit" class="btn btn-primary" onclick="Swal.close()">執行</button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div class="card w-100 mb-5 shadow-lg overflow-hidden">
        @if ($repair_orders->isEmpty())
            <div class="card-body w-100">
                <h5 class="card-title text-center">目前查無相關資料</h5>
            </div>
        @else
            <div class="card-body w-100 p-0">
                <table class="table table-striped  text-center m-0">
                    <thead class="table-secondary">
                        <tr class="text-center">
                            {{-- <th scope="col"><input class="form-check-input" type="checkbox" id="check-all" /></th> --}}
                            <th scope="col" width="5%">序號</th>
                            <th scope="col" width="10%">維修單號</th>
                            <th scope="col" width="6%">姓名</th>
                            <th scope="col" width="6%">手機</th>
                            <th scope="col" width="6%">市話</th>
                            <th scope="col" width="*">公司</th>
                            <th scope="col" width="6%">統編</th>
                            <th scope="col" width="10%">取件日期</th>
                            <th scope="col" width="10%">建檔日期</th>
                            <th scope="col" width="15%">操作</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($repair_orders as $index => $repair_order)
                            <tr>
                                {{-- <th class="text-center" scope="row"><input class="form-check-input" type="checkbox" name="item[]" value="{{ $index + 1 }}" /></th> --}}
                                <th class="text-center" scope="row">{{ $index + 1 }}</th>
                                <td class="text-center">{{ $repair_order->no }}</td>
                                <td>{{ $repair_order->name }}</td>
                                <td>{{ $repair_order->mobile }}</td>
                                <td>{{ $repair_order->phone }}</td>
                                <td>{{ $repair_order->company_name }}</td>
                                <td>{{ $repair_order->tax_id_number }}</td>
                                <td>{!! $repair_order->pickup_date ? $repair_order->pickup_date : "<button type='button' class='btn btn-sm btn-warning'>尚未取件</button>" !!}</td>
                                <td>{{ $repair_order->created_at }}</td>
                                <td class="d-flex justify-content-center">
                                    {{-- <div class="mx-2"><a href="{{ route('repair_order.show', $repair_order->sn) }}"><button type="button" class="btn btn-outline-info">查看</button></a></div> --}}
                                    <div class="mx-2"><a href="{{ route('preview-pdf', ['repair_order', $repair_order->sn]) }}" target="_blank"><button type="button" class="btn btn-outline-info">預覽</button></a></div>
                                    <div class="mx-2"><a href="{{ route('repair_order.edit', $repair_order->sn) }}"><button type="button" class="btn btn-outline-primary">編輯</button></a></div>
                                    <div class="mx-2">
                                        <form name="delete-form" action="{{ route('repair_order.destroy', $repair_order->sn) }}" method="POST">
                                            @csrf
                                            @method('delete')
                                            <button type="submit" class="btn btn-outline-danger" onclick="return formDeleteConfirm()">刪除</button>
                                        </form>
                                    </div>
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @endif
    </div>

    {{ $repair_orders->links() }}

    @vite(['resources/js/pages/repair_order/index.js'])
@endsection